# [Gemini](https://gemini.circumlunar.space/)


I've been keeping gemini protocol at my radar for some time now. It seemed like an interesting idea, but I was not sure if I wanted to take the (few minutes of) time to select and install a client and try it.

Then I did - it was one of those moments, when you realize that there is no way back (similar to when I first saw e.g. Linux).

I encourage you to try it. Here are a few reasons, but the main reason is, that **you might just love it**.

## Reasons to use gemini:
  - **It is so lovable!**
  - Extremely simple text format
  - You can self-publish in seconds
  - You do not need CMS, Wordpress, Hugo, etc, etc. You do not even need hosting, in fact ([tildeverse](https://tildeverse.org) is there for you).
  - It could tap into the creative potential of the billions of internet users, that currently stay at the consumer site of internet.
  - **So**, I guess you get it already, **it is real good**!


## How to browse gemini capsules


Gemini capsules are the gemini alternative to web pages.

You'd need a [gemini client](https://gemini.circumlunar.space/software/) to browse them. 

I use [Lagrange](https://github.com/skyjake/lagrange).

It has a beautifully themed GUI and other nice features.


## How to write Gemtext


[Gemtext](https://gemini.circumlunar.space/docs/gemtext.gmi) is the (exteremey simple) text format of gemini.

Here's a taste of it (in fact almost all of it):

```# Almost all about Gemini```

```## The protocol superb``` 

```=> https://gemini.circumlunar.space/ Start here```

```* Use it for your own good```

```* And for the benefit of all mankind!```

## How to have gemini capsule up and running


### Get an account for a [tildeverse server](https://tildeverse.org). Mine is on [ctrl-c.club](https://ctrl-c.club/)


Then just drop your gemtext files in your ```public_gemini``` directory at your tilde server. (Or follow similar simple instructions for your specific tilde server).

### Alternatively, you could setup your own gemini server


You could follow the instructions in the concise and excellent [landchad.net](https://landchad.net/gemini.html) article.


## Conclusion


Hopefully, that gave you the motivation boost to go grab [tildeverse server](https://tildeverse.org) account now; drop there some beatiful gems of your writing and shine on!

